{ stdenv, lib, linuxPackages, fetchurl }:

let
  kernel = linuxPackages.kernel;
  kernelDir = "${kernel.dev}/lib/modules/${kernel.modDirVersion}/build";
in

stdenv.mkDerivation rec {
  name = "tuxedo-keyboard";
  version = "v3.0.8";

  src = builtins.fetchGit {
    url = "git://github.com/tuxedocomputers/tuxedo-keyboard";
    ref = "refs/tags/${version}";
  };

  nativeBuildInputs = kernel.moduleBuildDependencies;

  buildPhase = ''
    make KDIR='${kernelDir}' all
  '';

  installPhase = ''
    install -v -D -m 644 \
      -t "$out/lib/modules/${kernel.modDirVersion}/extra/" \
      ./src/tuxedo_keyboard.ko \
      ./src/clevo_wmi.ko \
      ./src/tuxedo_io/tuxedo_io.ko \
      ./src/clevo_acpi.ko

    find -name '*.ko'
    echo ${kernel.modDirVersion}
  '';

  meta = {
    homepage = https://github.com/tuxedocomputers/tuxedo-keyboard/blob/master/Makefile;
  };

}
